package com.gic.haoban.manage.service.dao.mapper;


import com.gic.haoban.manage.service.entity.TabHaobanOperationSetting;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 操作设置表(TabHaobanOperationSetting)表数据库访问层
 *
 * @author YongEn
 * @date 2021-08-26 10:39:45
 */
@Repository
public interface TabHaobanOperationSettingMapper {

    /**
     * 新增数据
     *
     * @param setting 实例对象
     * @return 影响行数
     */
    int insert(TabHaobanOperationSetting setting);

    /**
     * 修改数据
     *
     * @param setting 实例对象
     * @return 影响行数
     */
    int update(TabHaobanOperationSetting setting);

    /**
     * 通过主键删除数据
     *
     * @param settingId 主键
     * @return 影响行数
     */
    int deleteById(String settingId);

    /**
     * 通过ID查询单条数据
     *
     * @param settingId 主键
     * @return 实例对象
     */
    TabHaobanOperationSetting queryById(String settingId);

    /**
     * 通过实体作为筛选条件查询
     *
     * @param setting 实例对象
     * @return 对象列表
     */
    List<TabHaobanOperationSetting> queryAll(TabHaobanOperationSetting setting);

    /**
     * 分页总数
     *
     * @return 对象列表
     */
    int queryCountByPage();


    /**
     * 分页列表
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<TabHaobanOperationSetting> queryListByPage(@Param("offset") int offset, @Param("limit") int limit);


}
