package com.gic.haoban.manage.service.dao.mapper;

import com.gic.haoban.manage.service.entity.TabHaobanWxEnterprise;
import com.github.pagehelper.Page;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Set;

public interface WxEnterpriseMapper {
    int deleteByPrimaryKey(String wxEnterpriseId);

    int insertSelective(TabHaobanWxEnterprise record);

    TabHaobanWxEnterprise selectByPrimaryKey(String wxEnterpriseId);

    int updateByPrimaryKeySelective(TabHaobanWxEnterprise record);

    Page<TabHaobanWxEnterprise> list(@Param("keyword") String keyword,
                                     @Param("enterpriseIds") List<String> enterpriseIds,
                                     @Param("gicContactFlag") Integer gicContactFlag,
                                     @Param("version") String version,
                                     @Param("enterpriseIdsNotIn") List<String> enterpriseIdsNotIn);

    List<TabHaobanWxEnterprise> listAll();

    List<TabHaobanWxEnterprise> listByIds(@Param("enterpriseIds") Set<String> wxEnterpriseIds);

    /**
     * 得到企业bycorpid
     *
     * @param corpId     公司标识
     * @param statusFlag 状态标志
     * @return {@link TabHaobanWxEnterprise }
     * @author mozhu
     * @date 2021-12-03 16:04:31
     */
    TabHaobanWxEnterprise getEnterpriseBycorpId(@Param("corpId") String corpId, @Param("statusFlag") Integer statusFlag);

    /**
     * 获取公司by企业名称
     *
     * @param corpName 公司名称
     * @return {@link TabHaobanWxEnterprise }
     * @author mozhu
     * @date 2021-12-20 20:09:52
     */
    TabHaobanWxEnterprise getEnterpriseByCorpName(@Param("corpName") String corpName);

    /**
     * 更新是否转化外部联系人
     *
     * @param externalFlag   外部标志
     * @param wxEnterpriseId wx企业标识
     * @return int
     * @author mozhu
     * @date 2021-12-30 20:40:59
     */
    int updateExternalFlagById(@Param("externalFlag") Integer externalFlag, @Param("wxEnterpriseId") String wxEnterpriseId);
}