package com.gic.haoban.manage.service.service;

import com.gic.haoban.manage.api.dto.SecretSettingDTO;
import com.gic.haoban.manage.service.entity.TabSecretSetting;

import java.util.List;

/**
 * Created 2020/6/3.
 *
 * @author hua
 */
public interface SecretSettingService {
    /**
     * 保存配置
     * @param secretSetting
     * @return
     */
    public boolean saveSecretSetting(SecretSettingDTO secretSetting);

    /**
     * 删除配置
     * @param secretId
     * @return
     */
    public boolean delSecretSetting(String secretId);

    /**
     * 根据企业查询配置项目
     * @param wxEnterpriseId
     * @return
     */
    public List<SecretSettingDTO> listSecretSetting(String wxEnterpriseId);

    /**
     * 根据非会员小程序类型获取
     * @param wxEnterpriseId
     * @param secretType
     * @return
     */
    public SecretSettingDTO getSecretSetting(String wxEnterpriseId,int secretType);

    /**
     * 根据会员小程序类型获取
     * @param wxEnterpriseId
     * @param enterpriseId
     * @return
     */
    public SecretSettingDTO getMemberSecretSetting(String wxEnterpriseId,String enterpriseId);
}
