package com.gic.haoban.manage.web.auth;

import com.alibaba.fastjson.JSON;
import com.gic.haoban.common.utils.EntityUtil;
import com.gic.haoban.manage.api.dto.LoginDTO;
import com.gic.redis.data.util.RedisUtil;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.util.Date;
import java.util.concurrent.TimeUnit;

/**
 * Created 2018/7/26.
 * 新方法 AuthWebRequestUtil
 * @author hua
 */
@Deprecated
public class AuthRequestUtil {

    private static final Logger logger = LoggerFactory.getLogger(AuthRequestUtil.class);

    public static final String REDIS_LOGIN_USER_TOKEN_PREFIX = "GIC:HAOBAN:HAOBAN_MOBILE_APP:LOGIN_USER:";
    public static final String REDIS_FAKE_LOGIN_FLAG_PREFIX = "GIC:HAOBAN:HAOBAN_MOBILE_APP:FAKE_LOGIN_TOKEN:";
    public static String LOGIN_SESSION_KEY = "HAOBAN:LOGINUSER";

    public static void setSessionUser(Object obj) {
        String userJson = JSON.toJSONString(obj);
        getSession().setAttribute(LOGIN_SESSION_KEY, userJson);
    }

    public static void delSessionUser() {
        getSession().removeAttribute(LOGIN_SESSION_KEY);
    }

    public static LoginDTO getAppLoginUser(String token) {
        logger.info("token-web=" + token);
        if (StringUtils.isBlank(token)) {
            return null;
        }
        return EntityUtil.changeEntityByJSON(LoginDTO.class, RedisUtil.getCache(token));
    }

    private static void setLoginUserLastToken(String token, Object obj) {
        try {
            String userId = BeanUtils.getProperty(obj, "user.userId");
            if (StringUtils.isNotBlank(userId) && StringUtils.isNotBlank(token)) {
                RedisUtil.setCache(REDIS_LOGIN_USER_TOKEN_PREFIX + userId, token, 31L, TimeUnit.DAYS);
            }
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
    }

    /**
     * 是否为用户最后一次登录token
     *
     * @param token
     * @param userId
     * @return
     */
    public static boolean isLoginUserLastToken(String token, String userId) {
        Object lastUserLoginToken = RedisUtil.getCache(REDIS_LOGIN_USER_TOKEN_PREFIX + userId);
        // 如果用户最后一次登录token不符则返回false
        return !(lastUserLoginToken instanceof CharSequence) || StringUtils.equals(token, (CharSequence) lastUserLoginToken);
    }

    private static void setFakeLoginFlag(String token) {
        if (StringUtils.isNotBlank(token)) {
            RedisUtil.setCache(REDIS_FAKE_LOGIN_FLAG_PREFIX + token, new Date(), 30L, TimeUnit.DAYS);
        }
    }

    /**
     * 是否为伪登录token
     *
     * @param token
     * @return
     */
    public static boolean isFakeLoginToken(String token) {
        return StringUtils.isNotBlank(token) && RedisUtil.getCache(REDIS_FAKE_LOGIN_FLAG_PREFIX + token) != null;
    }

    public static void setAppLoginUser(String token, Object obj) {
        RedisUtil.setCache(token, obj, 30L, TimeUnit.DAYS);
        getResponse().setHeader("token", token);
    }

    public static void setAppFakeLoginUser(String token, Object obj) {
        RedisUtil.setCache(token, obj, 30L, TimeUnit.DAYS);
        getResponse().setHeader("token", token);
        setFakeLoginFlag(token);
    }

    public static void delToken() {
        String token = getRequest().getHeader("token");
        RedisUtil.delCache(token);
    }

    public static void setAppLoginUser(Object obj, String token) {
        RedisUtil.setCache(token, obj, 30L, TimeUnit.DAYS);
        getResponse().setHeader("token", token);
    }

    public static void setAppFakeLoginUser(Object obj) {
        String token = getRequest().getHeader("token");
        RedisUtil.setCache(token, obj, 30L, TimeUnit.DAYS);
        getResponse().setHeader("token", token);
    }

    public static HttpSession getSession() {
        HttpSession session = null;
        try {
            session = getRequest().getSession();
        } catch (Exception e) {
        }
        return session;
    }

    public static HttpServletRequest getRequest() {
        ServletRequestAttributes attrs = (ServletRequestAttributes) RequestContextHolder
                .getRequestAttributes();
        return attrs.getRequest();
    }

    public static HttpServletResponse getResponse() {
        ServletRequestAttributes attrs = (ServletRequestAttributes) RequestContextHolder
                .getRequestAttributes();
        return attrs.getResponse();
    }

    public static LoginDTO getLoginUser() {
        Cookie[] cookies = getRequest().getCookies();
        String token = "";
        if (cookies != null) {
            for (Cookie cookie : cookies) {
                if (cookie.getName().equals("token")) {
                    token = cookie.getValue();
                }
            }
        }
        return getAppLoginUser(token);
    }
}
